const std = @import("std");
const mem = std.mem;
const net = std.net;
const http = std.http;
const heap = std.heap;

pub const Application = @import("application.zig").Application;

pub fn main() !void {
    var gpa = std.heap.GeneralPurposeAllocator(.{}){};
    defer _ = gpa.deinit();
    const allocator = gpa.allocator();

    const address = try net.Address.parseIp("0.0.0.0", 8080);
    var listener = App.init(.{
        .address = address,
        .allocator = allocator,
        .root_handler = &handleError,
    });
    defer listener.deinit();

    // try listener.router.putRoute("/", &handle);
    // try listener.router.putRoute("/error", &handleError);
    // try listener.router.putRoute("//pee", &handleError);
    // try listener.router.putRoute("/error/*", &handleError);

    try listener.listen();
}

const App = Application(DummyContext);
const DummyContext = struct {};

fn handle(event: *App.Event) anyerror!void {
    try event.res.body.appendSlice("hello there");
}

fn handleError(event: *App.Event) anyerror!void {
    try event.res.body.appendSlice("ahoy, an error occurred");
}
